from DecisionTableRuleCombine import *
def genSortData(CondTab):
    N1=len(CondTab[0]);A=array(N1,3)
    N2=len(CondTab)
    for i in range(N1):
        A[i][0]=i;NB=0;NY=0;NN=0
        for j in range(N2):
            if   CondTab[j][i]==1: NY+=1
            elif CondTab[j][i]==0: NN+=1
            else:                  NB+=1
        A[i][1]=NB; A[i][2]=abs(NY-NN)
    return A
def sortCond(A):
    N=len(A)
    for i in range(N-1):
        for j in range(N-1,i,-1):
            cmp=False
            if A[j-1][1]>A[j][1]:cmp=True
            elif A[j-1][1]==A[j][1]:
                if A[j-1][2]>A[j][2]:cmp=True
            if cmp:
                T=A[j-1];A[j-1]=A[j];A[j]=T
    return A
def replaceCond(A,CondTab):
    N1=len(CondTab[0]);N2=len(CondTab);newC=array(N2,N1)
    for i in range(N1):
        for j in range(N2):
            newC[j][i]=CondTab[j][A[i][0]]
    return newC

        
    
CondTab=[[1,-1,1,1],[1,-1,1,0],[1,-1,0,1],[1,-1,0,0],
         [0,1,1,1],[0,1,1,0],[0,1,0,1],[0,1,0,0]]
ActionTab=[[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],
           [1,1,0,0],[1,1,0,0],[1,1,0,0],[1,1,0,0]]
print("\n■実行前")
printDtab(CondTab,ActionTab)
print()
printDtree(DtabToTree(CondTab))

Ntab=ruleCombine(CondTab,ActionTab,True)
printDtab(Ntab[0],Ntab[1])
print()
printDtree(DtabToTree(Ntab[0]))

print("\n■最終結果")
printDtab(Ntab[0],Ntab[1])
print()
printDtree(DtabToTree(Ntab[0]))

X1=genSortData(Ntab[0])
print(X1)
X2=sortCond(X1)
print(X2)
newC=replaceCond(X2,Ntab[0])
printDtab(newC,Ntab[1])
printDtree(DtabToTree(newC))




